module charon.common.tree;

import charon.common.node;

export class Tree(T) : Node!(T) {
	protected:
		Tree m_left;
		Tree m_right;
	
	export:
		Tree left()
			in {
			
			}
			out (response) {
				assert(response == m_left);
			}
			body {
				return m_left;
			}
	
		Tree left(Tree t)
			in {
				assert(!(t is null));
			}
			out {
				assert(m_left == t);
			}
			body {
				return (m_left = t);
			}
		
		Tree right()
			in {
			
			}
			out (response) {
				assert(response == m_right);
			}
			body {
				return m_right;
			}
		
		Tree right(Tree t)
			in {
				assert(!(t is null));
			}
			out {
				assert(m_right == t);
			}
			body {
				return (m_right = t);
			}
}