module charon.common.array;

export class Array(T) {

	protected:
		T[] m_array;
		
	export:
		this()
			in {
			
			}
			out {
			
			}
			body {
			
			}
		
		this(T o)
			in {
			
			}
			out {
				assert(m_array.length == 1);
				assert(m_array[0] == o);
			}
			body {
				m_array[0] = o;
			}
		
		this(T[] o)
			in {
				assert(o.length > 0);
			}
			out {
				assert(m_array.length > 0);
				assert(m_array.length == o.length);
				for (int i=0; i<m_array.length; i++) {
					assert(m_array[i] == o[i]);
				}
			}
			body {
				m_array = o.dup;
			}
			
		int length ()
			in {
		
			}
			out (response) {
				assert(response == m_array.length);
			}
			body {
				return m_array.length;
			}

		int length(int l)
			in {
				assert(l !=0);
			}
			out (response) {
				assert(response == l);
				assert(response == m_array.length);
				assert(m_array.length == l);
			}
			body {
				return (m_array.length = l);
			}
      
		void clear ()
			in {
		
			}
			out {
				assert(m_array.length == 0);
			}
			body {
				m_array.length = 0;
			}
}