module charon.common.queue;

import charon.common.array;
import charon.common.enqueue;

export class Queue(T) : Array!(T),Enqueue!(T) {
	
	export:
		T pop ()
			in {
		
			}
			out (response) {
				
			}
			body {
				T next = m_array[0];
				m_array = m_array[1..m_array.length];
				return next;
			}
      
		T push (T o)
			in {
				
			}
			out (response) {
				assert(response == o);
				assert(m_array[m_array.length-1] == o);
				assert(m_array[m_array.length-1] == response);
			}
			body {
				int rear = m_array.length;
				m_array.length = rear + 1;
				return (m_array[rear] = o); 
			}
		
		T peek (int n)
			in {
				assert(n < m_array.length);
			}
			out (response){
				assert(response == m_array[0]);
			}
			body {
				return m_array[n];
			}
}