module charon.common.stack;

import charon.common.array;
import charon.common.enqueue;

export class Stack(T) : Array!(T),Enqueue!(T) {
     
	export:
		T pop ()
			in {
		
			}
			out (response) {
				assert(!(response is null));
			}
			body {
				T next = m_array[0];
				m_array = m_array[1..m_array.length];
				return next;
			}
      
		T push (T o)
			in {
				assert(!(o is null));
			}
			out (response) {
				assert(response == o);
				assert(m_array[m_array.length-1] == o);
				assert(m_array[m_array.length-1] == response);
			}
			body {
				T[1] working;
				working[0] = o;
				m_array = working ~ m_array;
				return m_array[0];
			}
			
		T peek (int n)
			in {
				assert(n < m_array.length);
			}
			out (response) {
				assert(!(response is null));
				assert(response == m_array[0]);
			}
			body {
				return m_array[n];
			}
}